function [err]=ZLB_eqm_one_period_stochastic(Zprevious,Z,Ztomorrow,a,rr,psi,epsilon,theta,rhoR,phic,phipi,G,Rss,Css)
% EXPLANATION
% This code computes the eqm condition for a particular period.
% ZLB_eqm_conditions.m computes the errors for every period.
% Namely ZLB_eqm_conditions.m stacks the errors computed by this code.
% INPUT
% Zprevious : z(t-1)
% Z : z(t) 
% Ztomorrow : z(t+1)
% a : productivity

%% The code starts from here...

% Z(t-1)
%Cm1=Zprevious(1);
pstarm1=Zprevious(2);
%Nm1=Zprevious(3);
%pibarm1=Zprevious(4);
%Km1=Zprevious(5);
%Fm1=Zprevious(6);
Rm1=Zprevious(7);

% Z(t)
C=Z(1);
pstar=Z(2);
N=Z(3);
pibar=Z(4);
K=Z(5);
F=Z(6);
R=Z(7);

% Z(t+1)
Cp1=Ztomorrow(1);
%pstarp1=Ztomorrow(2);
%Np1=Ztomorrow(3);
pibarp1=Ztomorrow(4);
Kp1=Ztomorrow(5);
Fp1=Ztomorrow(6);
%Rp1=Ztomorrow(7);

% MU and MRS today
uc = 1/C;
mrs = N^psi*C;
ucp1 = 1/Cp1;
%mrsp1 = Np1^psi*Cp1;


% compute the errors.
err=nan(length(Z),1);
% dynamics of K
err(1)=K-mrs/exp(a) - theta*(1/(1+rr))*pibarp1^epsilon*Kp1;

% dynamics of F
err(2)=F-1-theta*(1/(1+rr))*pibarp1^(epsilon-1)*Fp1;

% price setting
err(3)=K/F-((1-theta*pibar^(epsilon-1))/(1-theta))^(1/(1-epsilon));

% price dispersion
err(4)=pstar-1/((1-theta)*((1-theta*pibar^(epsilon-1))/(1-theta))^(epsilon/(epsilon-1))+theta*pibar^epsilon/pstarm1);

% Euler eq
err(5)=1-(1/(1+rr))*R*(ucp1/uc)/pibarp1;

% Resource constraint
err(6)=C+G  -  pstar * N * exp(a);

% Taylor rule
err(7)=R-Rss*max([1/Rss (Rm1/Rss)^rhoR*((C/Css)^phic*pibar^phipi)^(1-rhoR)]);


