function [c p n infn K F R w] =ss_ZLB(beta,theta,g,psi)
%EXPLANATION
% INPUT
% epsi : elasticity of the final good production function
% beta : discount factor
% theta : Calvo parameter
% g : government purchase per output
% psi : labor disutility
% u(C,N) = log(C) - N^(1+psi)/(1+psi);
%OUTPUT
% the associated steady state values



F=1/ (1-beta*theta);
K=F;
w=1;
p=1;
R=1/beta;
infn=1;

n = (1-g)^(   -1/(1+psi)  );
c  = (1-g)*n;


if norm(c*n^psi-1) >1e-10
    error('Fatal error')
end



