% This is a subcode for main_ZLB_stochastic.
% Compute the stochastic simulation.

for i = 1 : T-1

    if i ==tp+1
        r_path = rh * ones(T,1);
    end
    
    % Note that objective contains i for the info about a_path
    objective=@(X) ZLB_eqm_conditions_stochastic(X,Zss,i,a_path,r_path,psi,epsilon,theta,rhoR,phic,phipi,g);
    
    
    [Z_star,fval,exitflag]=fsolve(objective,Z_initial_guess,options);
    Z_star = reshape(Z_star,N,T-i+1); % Z_star = (Z_t, Z_t+1_hat,...)
    
    % Store the forecast at time t
    Z_forecast{i,1} = Z_star;
    % Store the actual realization at time t
    Z_actual(:,i) = Z_star(:,1);


    % Use the forecast as the initial guess
    Z_initial_guess = Z_star(:,2:end);
    Z_initial_guess = Z_initial_guess(:);


    % Small check    
    if  max(abs(fval)) > .1e-10
        error('fatal failed to solve for baseline equilibrium')
    end
    
    if exitflag~=1
        disp('The solution might not be optimal even though it is close to 0...')
    end
    i
    
end

save stochastic_simulation_with_impulse;